
#include <stdlib.h>
#include <unistd.h>
#include "Stack.h"

Stack<int> s1(10), s2(10), s3(10);
const char *base = "================================================";

void Hanoi (int n, Stack<int> &s1, Stack<int> &s2, Stack<int> &s3);


void PrintStacks();
void SetLine(char *s, int k, int k1, int k2, int k3);



int main()
{

    for (int i=4; i>=0; i--) {
      s1.Push(2*i+1);
      system("cls");
      PrintStacks();
      sleep(1);
    }
    Hanoi(s1.Size(),s1,s2,s3);
    getchar();
    PrintStacks();

    return 0;
}


void Hanoi (int n, Stack<int> &s1, Stack<int> &s2, Stack<int> &s3)
{
    if (n==0) return;

    Hanoi(n-1, s1, s3, s2);

    s3.Push(s1.Top());
    s1.Del();

      system("cls");
      PrintStacks();
      sleep(1);

    Hanoi(n-1, s2, s1, s3);
}





void PrintStacks()
{
   char s[128];
   int n = s1.Maxsize();
   int n1, n2, n3;
   int k1, k2, k3;
   n1 = s1.Size();
   n2 = s2.Size();
   n3 = s3.Size();
   putchar('\n');
   for (int i=n-1; i>=0; i--) {
		k1 = (i>=n1) ? 0 : s1.mem[i];
		k2 = (i>=n2) ? 0 : s2.mem[i];
		k3 = (i>=n3) ? 0 : s3.mem[i];
        SetLine(s, n, k1, k2, k3);
        printf("%s\n",s);
   }
   printf("%s\n",base);
}


void SetLine(char *s, int k, int k1, int k2, int k3)
{
    int m1, m2, m3;
    m1 = k/2 + 2;
    m2 = m1 + k + 3;
    m3 = m2 + k + 3;
    int len = 3*k+8;
    for (int i=0; i<len; i++) s[i] = ' ';
    s[len] = 0;
	s[m1] = ':';
	s[m2] = ':';
	s[m3] = ':'; 
    for (int i=0; i<k1; i++) s[m1-k1/2+i] = '=';
    for (int i=0; i<k2; i++) s[m2-k2/2+i] = '=';
    for (int i=0; i<k3; i++) s[m3-k3/2+i] = '=';
}